#include <wx/wx.h>
#include <DatabaseLayer.h>
#include <SqliteDatabaseLayer.h>
#include <DatabaseLayerException.h>

int main()
{
	int returnCode(0);
	DatabaseLayer * connection(NULL);
	DatabaseResultSet * result(NULL);
	do
	{
		try
		{
			connection = new SqliteDatabaseLayer(wxT("Minimal.sqlite"), false);
			result = connection->RunQueryWithResults(
				wxT("SELECT * FROM sqlite_master WHERE type='table'"));
			if(!result || !result->Next())
			{
				connection->RunQuery(
					wxT("CREATE TABLE SampleTable \
						(ID INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, \
						Name VARCHAR(32))"));
				for(int i = 0; i < 5; i++)
				{
					connection->RunQuery(wxString::Format(
						wxT("INSERT INTO SampleTable (Name) VALUES ('%i')"), rand()));
				}
			}
			if(result) 
			{
				connection->CloseResultSet(result);
				result = NULL;
			}
			result = connection->RunQueryWithResults(wxT("SELECT * FROM SampleTable"));
			if(!result) 
			{
				returnCode = 1;
				break;
			}
			while (result->Next())
			{
				wxPrintf(wxT("%d - %s\r\n"),
					result->GetResultInt(wxT("ID")), 
					result->GetResultString(wxT("Name")).GetData());
			}
		}
		catch(DatabaseLayerException & e)
		{
			returnCode = 2;
			wxPrintf(wxT("%d %s"), e.GetErrorCode(), e.GetErrorMessage().GetData());
		}
	}
	while(false);
	if(connection)
	{
		if(result) connection->CloseResultSet(result);
	}
	wxDELETE(connection);
	getchar();
	return returnCode;
}
